using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;


namespace GGC_Group
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(40, 24);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(520, 288);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "3.301.0.0";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(480, 304);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(72, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 334);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 20;
			Random r = new Random(15345345);

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = r.Next(10);
				dt.Rows.Add(dr);
			}

			this.gridGroupingControl1.DataSource = dt;

			this.gridGroupingControl1.ShowGroupDropArea = true;

			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("Col1");

			this.gridGroupingControl1.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);

			this.gridGroupingControl1.TableControlCurrentCellActivated +=new GridTableControlEventHandler(gridGroupingControl1_TableControlCurrentCellActivated);
			

		}

		private void gridGroupingControl1_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
		{
			
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			GridCurrentCell cc= this.gridGroupingControl1.TableControl.CurrentCell;  
			Element el = this.gridGroupingControl1.Table.DisplayElements[cc.RowIndex];
			Console.WriteLine(el); 
			if( el.Kind == DisplayElementKind.Caption )
			{
				if( el.ParentGroup != null
					&& el.ParentGroup.ParentChildTable != null)
				{
					foreach(Record rec in el.ParentGroup.Records)
						Console.WriteLine(rec); 
					
				}
  
			}
		}

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			if( e.Style.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionCell)
			{
				e.Style.Enabled = true;
				e.Style.CellType = "TextBox"; 
			}
		}

		private void gridGroupingControl1_TableControlCurrentCellActivated(object sender, GridTableControlEventArgs e)
		{
			GridCurrentCell cc= e.TableControl.CurrentCell;  
			Element el = e.TableControl.Table.DisplayElements[cc.RowIndex];
			if( el.Kind == DisplayElementKind.Caption )
			{
				if( el.ParentGroup != null
					&& el.ParentGroup.ParentChildTable != null)
				{
					foreach(Record rec in el.ParentGroup.Records)
						Console.WriteLine(rec); 
				}
			}
		}
	}
}
